import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import CodeMirror from 'codemirror';
import 'codemirror/mode/javascript/javascript';
import 'codemirror/mode/htmlmixed/htmlmixed';
import 'codemirror/addon/display/autorefresh'; // https://codemirror.net/doc/manual.html#addon_autorefresh

import 'codemirror/addon/display/fullscreen';
import 'codemirror/addon/selection/active-line';
import 'codemirror/addon/fold/foldcode';
import 'codemirror/addon/fold/foldgutter';
import 'codemirror/addon/fold/brace-fold';
import 'codemirror/addon/fold/indent-fold';
import 'codemirror/addon/edit/matchbrackets';
import 'codemirror/addon/edit/closebrackets';
import 'codemirror/addon/edit/closetag';
import 'codemirror/addon/dialog/dialog';
import 'codemirror/addon/search/search';
import 'codemirror/addon/search/searchcursor';
import 'codemirror/addon/search/jump-to-line';
import 'codemirror/addon/search/matchesonscrollbar';
import 'codemirror/addon/lint/lint';
import '../addon/lint/json'; // 官方的 JSON Lint 有问题 https://github.com/scniro/react-codemirror2/issues/21

export default function createEditor(div, value) {
  var _conf$theme;

  var conf = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return CodeMirror(div, _objectSpread({
    value: value,
    mode: 'text/plain',
    // 支持的 mode 可以查看 mode 模块的末尾
    // display
    theme: (_conf$theme = conf.theme) !== null && _conf$theme !== void 0 ? _conf$theme : conf.readOnly ? 'mdn-like' : 'oceanic-next',
    // 额外的 theme 要应用自行安装
    indentUnit: 2,
    lineNumbers: true,
    lineWrapping: true,
    styleActiveLine: !conf.readOnly,
    gutters: ['CodeMirror-lint-markers', 'CodeMirror-linenumbers', 'CodeMirror-foldgutter'],
    foldGutter: true,
    matchBrackets: true,
    // ease
    fullScreen: false,
    autoRefresh: true,
    autoCloseBrackets: '()[]{}\'\'""',
    autoCloseTags: true,
    // others
    lint: !conf.readOnly,
    extraKeys: {
      Tab: false
    }
  }, conf));
}